Tuesday, February 27, 2024

[LeetCode] Find the Difference of Two Arrays

Problem: Given two 0-indexed integer arrays nums1 and nums2, return a list answer of size 2 where:

  • answer[0] is a list of all distinct integers in nums1 which are not present in nums2.
  • answer[1] is a list of all distinct integers in nums2 which are not present in nums1.

Note that the integers in the lists may be returned in any order.

Example:

Input: nums1 = [1,2,3], nums2 = [2,4,6]
Output: [[1,3],[4,6]]
Explanation:
For nums1, nums1[1] = 2 is present at index 0 of nums2, whereas nums1[0] = 1 and nums1[2] = 3 are not present in nums2. Therefore, answer[0] = [1,3].
For nums2, nums2[0] = 2 is present at index 1 of nums1, whereas nums2[1] = 4 and nums2[2] = 6 are not present in nums2. Therefore, answer[1] = [4,6].
Input: nums1 = [1,2,3,3], nums2 = [1,1,2,2]
Output: [[3],[]]
Explanation:
For nums1, nums1[2] and nums1[3] are not present in nums2. Since nums1[2] == nums1[3], their value is only included once and answer[0] = [3].
Every integer in nums2 is present in nums1. Therefore, answer[1] = [].


Approach: We can use HashSets to solve this issue. Just look at the implementation to understand the solution as it is straight forward.


Implementation in C#:

    public IList<IList<int>> FindDifference(int[] nums1, int[] nums2)
    {
        HashSet<int> num1Set = new HashSet<int>(nums1);
        HashSet<int> num2Set = new HashSet<int>(nums2);
        List<int> numsToRemove = new List<int>();
        foreach (int num in num1Set)
        {
            if (num2Set.Contains(num))
            {
                numsToRemove.Add(num);
            }
        }
        foreach (int num in numsToRemove)
        {
            num1Set.Remove(num);
            num2Set.Remove(num);
        }
        return new List<IList<int>> { num1Set.ToList(), num2Set.ToList() };
    }

Complexity: O(n)

No comments:

Post a Comment